"use strict";

var _interopRequireDefault = require("@babel/runtime-corejs2/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.mount = mount;

var _react = _interopRequireDefault(require("react"));

var _reactDom = require("react-dom");

var _util = require("react-cosmos-shared2/util");

var _dom = require("react-cosmos-shared2/dom");

var _reactCosmosFixture = require("react-cosmos-fixture");

var _userModulesNext = require("./user-modules-next");

var rendererId = getRendererId();

function mount() {
  (0, _reactDom.render)(isInsideIframe() ? _react.default.createElement(_reactCosmosFixture.PostMessage, null, renderFixtureConnect) : // TODO: Allow user to input URL
  _react.default.createElement(_reactCosmosFixture.WebSockets, {
    url: "localhost:8989"
  }, renderFixtureConnect), (0, _dom.getDomContainer)());
}

function renderFixtureConnect(_ref) {
  var subscribe = _ref.subscribe,
      unsubscribe = _ref.unsubscribe,
      postMessage = _ref.postMessage;
  return _react.default.createElement(_reactCosmosFixture.FixtureConnect, {
    rendererId: rendererId,
    fixtures: _userModulesNext.fixtures,
    decorators: _userModulesNext.decorators,
    subscribe: subscribe,
    unsubscribe: unsubscribe,
    postMessage: postMessage
  });
}

function isInsideIframe() {
  try {
    return window.self !== window.top;
  } catch (e) {
    return true;
  }
} // Renderer ID is remembered to avoid announcing a new renderer when reloading
// the renderer window. Note that each tab has creates a new session and thus
// a new rendererId.
// https://developer.mozilla.org/en-US/docs/Web/API/Window/sessionStorage


function getRendererId() {
  var rendererId = sessionStorage.getItem('cosmosRendererId');

  if (!rendererId) {
    rendererId = (0, _util.uuid)();
    sessionStorage.setItem('cosmosRendererId', rendererId);
  }

  return rendererId;
}